import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { HouseReservation, HouseReservationParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询预约记录表
 */
export async function pageHouseReservation(params: HouseReservationParam) {
  const res = await request.get<ApiResult<PageResult<HouseReservation>>>(
    MODULES_API_URL + '/house/house-reservation/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询预约记录表列表
 */
export async function listHouseReservation(params?: HouseReservationParam) {
  const res = await request.get<ApiResult<HouseReservation[]>>(
    MODULES_API_URL + '/house/house-reservation',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加预约记录表
 */
export async function addHouseReservation(data: HouseReservation) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-reservation',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改预约记录表
 */
export async function updateHouseReservation(data: HouseReservation) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-reservation',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除预约记录表
 */
export async function removeHouseReservation(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-reservation/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除预约记录表
 */
export async function removeBatchHouseReservation(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/house/house-reservation/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询预约记录表
 */
export async function getHouseReservation(id: number) {
  const res = await request.get<ApiResult<HouseReservation>>(
    MODULES_API_URL + '/house/house-reservation/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
